diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/txop.cc ns-3.41/src/wifi/model/txop.cc
--- ns-3.40/src/wifi/model/txop.cc	2023-09-27 13:30:37.914839700 -0700
+++ ns-3.41/src/wifi/model/txop.cc	2024-02-09 14:44:08.597795000 -0800
@@ -230,7 +230,6 @@
 Ptr<WifiMacQueue>
 Txop::GetWifiMacQueue() const
 {
-    NS_LOG_FUNCTION(this);
     return m_queue;
 }
 
@@ -535,17 +534,29 @@
 {
     NS_LOG_FUNCTION(this << *mpdu);
     const auto linkIds = m_mac->GetMacQueueScheduler()->GetLinkIds(m_queue->GetAc(), mpdu);
+    std::map<uint8_t, bool> hasFramesToTransmit;
+
+    // save the status of the AC queues before enqueuing the MPDU (required to determine if
+    // backoff is needed)
     for (const auto linkId : linkIds)
     {
-        if (m_mac->GetChannelAccessManager(linkId)->NeedBackoffUponAccess(this))
-        {
-            GenerateBackoff(linkId);
-        }
+        hasFramesToTransmit[linkId] = HasFramesToTransmit(linkId);
     }
     m_queue->Enqueue(mpdu);
     for (const auto linkId : linkIds)
     {
-        StartAccessIfNeeded(linkId);
+        // schedule a call to StartAccessIfNeeded() to request channel access after that all the
+        // packets of a burst have been enqueued, instead of requesting channel access right after
+        // the first packet. The call to StartAccessIfNeeded() is scheduled only after the first
+        // packet
+        if (auto& event = GetLink(linkId).accessRequest.event; !event.IsRunning())
+        {
+            event = Simulator::ScheduleNow(&Txop::StartAccessAfterEvent,
+                                           this,
+                                           linkId,
+                                           hasFramesToTransmit.at(linkId),
+                                           CHECK_MEDIUM_BUSY);
+        }
     }
 }
 
@@ -558,13 +569,24 @@
 }
 
 void
-Txop::StartAccessIfNeeded(uint8_t linkId)
+Txop::StartAccessAfterEvent(uint8_t linkId, bool hadFramesToTransmit, bool checkMediumBusy)
 {
-    NS_LOG_FUNCTION(this << +linkId);
-    if (HasFramesToTransmit(linkId) && GetLink(linkId).access == NOT_REQUESTED)
+    NS_LOG_FUNCTION(this << +linkId << hadFramesToTransmit << checkMediumBusy);
+
+    if (GetLink(linkId).access != NOT_REQUESTED || !HasFramesToTransmit(linkId))
     {
-        m_mac->GetChannelAccessManager(linkId)->RequestAccess(this);
+        NS_LOG_DEBUG("No need to request channel access on link " << +linkId);
+        return;
+    }
+
+    if (m_mac->GetChannelAccessManager(linkId)->NeedBackoffUponAccess(this,
+                                                                      hadFramesToTransmit,
+                                                                      checkMediumBusy))
+    {
+        GenerateBackoff(linkId);
     }
+
+    m_mac->GetChannelAccessManager(linkId)->RequestAccess(this);
 }
 
 void
@@ -646,7 +668,8 @@
 Txop::NotifyWakeUp(uint8_t linkId)
 {
     NS_LOG_FUNCTION(this << +linkId);
-    StartAccessIfNeeded(linkId);
+    // before wake up, no packet can be transmitted
+    StartAccessAfterEvent(linkId, DIDNT_HAVE_FRAMES_TO_TRANSMIT, DONT_CHECK_MEDIUM_BUSY);
 }
 
 void
@@ -655,7 +678,8 @@
     NS_LOG_FUNCTION(this);
     for (const auto& [id, link] : m_links)
     {
-        StartAccessIfNeeded(id);
+        // before being turned on, no packet can be transmitted
+        StartAccessAfterEvent(id, DIDNT_HAVE_FRAMES_TO_TRANSMIT, DONT_CHECK_MEDIUM_BUSY);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/txop.h ns-3.41/src/wifi/model/txop.h
--- ns-3.40/src/wifi/model/txop.h	2023-09-27 13:30:37.914839700 -0700
+++ ns-3.41/src/wifi/model/txop.h	2024-02-09 14:44:08.597795000 -0800
@@ -30,6 +30,8 @@
 #include <memory>
 #include <vector>
 
+class EmlsrUlTxopTest;
+
 namespace ns3
 {
 
@@ -394,6 +396,32 @@
     virtual ChannelAccessStatus GetAccessStatus(uint8_t linkId) const;
 
     /**
+     * Request channel access on the given link after the occurrence of an event that possibly
+     * requires to generate a new backoff value. Examples of such an event are: a packet has been
+     * enqueued by the upper layer; the given link has been unblocked after being blocked for some
+     * reason (e.g., wait for ADDBA Response, wait for TX on another EMLSR link to finish, etc.);
+     * the PHY operating on the given link just woke up from sleep mode. The <i>checkMediumBusy</i>
+     * argument is forwarded to the NeedBackoffUponAccess method of the ChannelAccessManager.
+     *
+     * \param linkId the ID of the given link
+     * \param hadFramesToTransmit whether packets available for transmission were queued just
+     *                            before the occurrence of the event causing this channel access
+     *                            request
+     * \param checkMediumBusy whether generation of backoff (also) depends on the busy/idle state
+     *                        of the medium
+     */
+    void StartAccessAfterEvent(uint8_t linkId, bool hadFramesToTransmit, bool checkMediumBusy);
+
+    static constexpr bool HAD_FRAMES_TO_TRANSMIT =
+        true; //!< packets available for transmission were in the queue
+    static constexpr bool DIDNT_HAVE_FRAMES_TO_TRANSMIT =
+        false; //!< no packet available for transmission was in the queue
+    static constexpr bool CHECK_MEDIUM_BUSY =
+        true; //!< generation of backoff (also) depends on the busy/idle state of the medium
+    static constexpr bool DONT_CHECK_MEDIUM_BUSY =
+        false; //!< generation of backoff is independent of the busy/idle state of the medium
+
+    /**
      * \param nSlots the number of slots of the backoff.
      * \param linkId the ID of the given link
      *
@@ -422,6 +450,7 @@
   protected:
     ///< ChannelAccessManager associated class
     friend class ChannelAccessManager;
+    friend class ::EmlsrUlTxopTest;
 
     void DoDispose() override;
     void DoInitialize() override;
@@ -441,12 +470,6 @@
      */
     virtual void GenerateBackoff(uint8_t linkId);
     /**
-     * Request access from Txop on the given link if needed.
-     *
-     * \param linkId the ID of the given link
-     */
-    virtual void StartAccessIfNeeded(uint8_t linkId);
-    /**
      * Request access to the ChannelAccessManager associated with the given link
      *
      * \param linkId the ID of the given link
@@ -505,6 +528,12 @@
         uint8_t aifsn{0};                          //!< the AIFSN
         Time txopLimit{0};                         //!< the TXOP limit time
         ChannelAccessStatus access{NOT_REQUESTED}; //!< channel access status
+
+        mutable class
+        {
+            friend void Txop::Queue(Ptr<WifiMpdu>);
+            EventId event;
+        } accessRequest; //!< access request event, to be used by Txop::Queue() only
     };
 
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/vht/vht-phy.cc ns-3.41/src/wifi/model/vht/vht-phy.cc
--- ns-3.40/src/wifi/model/vht/vht-phy.cc	2023-09-27 13:30:37.914839700 -0700
+++ ns-3.41/src/wifi/model/vht/vht-phy.cc	2024-02-09 14:44:08.597795000 -0800
@@ -369,7 +369,7 @@
     {                                                                                              \
         static WifiMode mcs = CreateVhtMcs(x);                                                     \
         return mcs;                                                                                \
-    };
+    }
 
 GET_VHT_MCS(0)
 GET_VHT_MCS(1)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-assoc-manager.cc ns-3.41/src/wifi/model/wifi-assoc-manager.cc
--- ns-3.40/src/wifi/model/wifi-assoc-manager.cc	2023-09-27 13:30:37.914839700 -0700
+++ ns-3.41/src/wifi/model/wifi-assoc-manager.cc	2024-02-09 14:44:08.601795200 -0800
@@ -305,7 +305,7 @@
     {
         auto ehtConfig = m_mac->GetEhtConfiguration();
         NS_ASSERT(ehtConfig);
-        EnumValue negSupport;
+        EnumValue<WifiTidToLinkMappingNegSupport> negSupport;
         ehtConfig->GetAttributeFailSafe("TidToLinkMappingNegSupport", negSupport);
 
         // A non-AP MLD that performs multi-link (re)setup on at least two links with an AP MLD
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-bandwidth-filter.cc ns-3.41/src/wifi/model/wifi-bandwidth-filter.cc
--- ns-3.40/src/wifi/model/wifi-bandwidth-filter.cc	2023-09-27 13:30:37.914839700 -0700
+++ ns-3.41/src/wifi/model/wifi-bandwidth-filter.cc	2024-02-09 14:44:08.601795200 -0800
@@ -137,4 +137,10 @@
     return filter;
 }
 
+int64_t
+WifiBandwidthFilter::DoAssignStreams(int64_t stream)
+{
+    return 0;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-bandwidth-filter.h ns-3.41/src/wifi/model/wifi-bandwidth-filter.h
--- ns-3.40/src/wifi/model/wifi-bandwidth-filter.h	2023-09-27 13:30:37.914839700 -0700
+++ ns-3.41/src/wifi/model/wifi-bandwidth-filter.h	2024-02-09 14:44:08.601795200 -0800
@@ -45,6 +45,9 @@
 
     bool DoFilter(Ptr<const SpectrumSignalParameters> params,
                   Ptr<const SpectrumPhy> receiverPhy) override;
+
+  protected:
+    int64_t DoAssignStreams(int64_t stream) override;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-default-ack-manager.cc ns-3.41/src/wifi/model/wifi-default-ack-manager.cc
--- ns-3.40/src/wifi/model/wifi-default-ack-manager.cc	2023-09-27 13:30:37.914839700 -0700
+++ ns-3.41/src/wifi/model/wifi-default-ack-manager.cc	2024-02-09 14:44:08.601795200 -0800
@@ -60,16 +60,17 @@
                           DoubleValue(0.0),
                           MakeDoubleAccessor(&WifiDefaultAckManager::m_baThreshold),
                           MakeDoubleChecker<double>(0.0, 1.0))
-            .AddAttribute("DlMuAckSequenceType",
-                          "Type of the acknowledgment sequence for DL MU PPDUs.",
-                          EnumValue(WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE),
-                          MakeEnumAccessor(&WifiDefaultAckManager::m_dlMuAckType),
-                          MakeEnumChecker(WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE,
-                                          "DL_MU_BAR_BA_SEQUENCE",
-                                          WifiAcknowledgment::DL_MU_TF_MU_BAR,
-                                          "DL_MU_TF_MU_BAR",
-                                          WifiAcknowledgment::DL_MU_AGGREGATE_TF,
-                                          "DL_MU_AGGREGATE_TF"))
+            .AddAttribute(
+                "DlMuAckSequenceType",
+                "Type of the acknowledgment sequence for DL MU PPDUs.",
+                EnumValue(WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE),
+                MakeEnumAccessor<WifiAcknowledgment::Method>(&WifiDefaultAckManager::m_dlMuAckType),
+                MakeEnumChecker(WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE,
+                                "DL_MU_BAR_BA_SEQUENCE",
+                                WifiAcknowledgment::DL_MU_TF_MU_BAR,
+                                "DL_MU_TF_MU_BAR",
+                                WifiAcknowledgment::DL_MU_AGGREGATE_TF,
+                                "DL_MU_AGGREGATE_TF"))
             .AddAttribute("MaxBlockAckMcs",
                           "The MCS used to send a BlockAck in a TB PPDU is the minimum between "
                           "the MCS used for the PSDU sent in the preceding DL MU PPDU and the "
@@ -572,7 +573,9 @@
                                           m_mac->GetBaTypeAsOriginator(receiver, tid)});
 
         acknowledgment->barTypes.push_back(m_mac->GetBarTypeAsOriginator(receiver, tid));
-        acknowledgment->muBarTxVector = GetWifiRemoteStationManager()->GetRtsTxVector(receiver);
+        acknowledgment->muBarTxVector =
+            GetWifiRemoteStationManager()->GetRtsTxVector(receiver,
+                                                          txParams.m_txVector.GetChannelWidth());
         acknowledgment->SetQosAckPolicy(receiver, tid, WifiMacHeader::BLOCK_ACK);
         return std::unique_ptr<WifiDlMuTfMuBar>(acknowledgment);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-default-protection-manager.cc ns-3.41/src/wifi/model/wifi-default-protection-manager.cc
--- ns-3.40/src/wifi/model/wifi-default-protection-manager.cc	2023-09-27 13:30:37.914839700 -0700
+++ ns-3.41/src/wifi/model/wifi-default-protection-manager.cc	2024-02-09 14:44:08.601795200 -0800
@@ -190,8 +190,8 @@
         return std::make_unique<WifiNoProtection>();
     }
 
-    // when an EMLSR client starts an UL TXOP on a link on which the main PHY is not operating,
-    // the aux PHY sends an RTS frame
+    // when an EMLSR client starts an UL TXOP on a link while the MediumSyncDelay timer is running
+    // or on a link on which the main PHY is not operating, it needs to send an RTS frame
     bool emlsrNeedRts = false;
 
     if (auto staMac = DynamicCast<StaWifiMac>(m_mac))
@@ -199,14 +199,17 @@
         auto emlsrManager = staMac->GetEmlsrManager();
 
         emlsrNeedRts = emlsrManager && staMac->IsEmlsrLink(m_linkId) &&
-                       m_mac->GetLinkForPhy(emlsrManager->GetMainPhyId()) != m_linkId;
+                       (emlsrManager->GetElapsedMediumSyncDelayTimer(m_linkId) ||
+                        m_mac->GetLinkForPhy(emlsrManager->GetMainPhyId()) != m_linkId);
     }
 
     // check if RTS/CTS is needed
     if (emlsrNeedRts || GetWifiRemoteStationManager()->NeedRts(hdr, size))
     {
         auto protection = std::make_unique<WifiRtsCtsProtection>();
-        protection->rtsTxVector = GetWifiRemoteStationManager()->GetRtsTxVector(hdr.GetAddr1());
+        protection->rtsTxVector =
+            GetWifiRemoteStationManager()->GetRtsTxVector(hdr.GetAddr1(),
+                                                          txVector.GetChannelWidth());
         protection->ctsTxVector =
             GetWifiRemoteStationManager()->GetCtsTxVector(hdr.GetAddr1(),
                                                           protection->rtsTxVector.GetMode());
@@ -300,7 +303,8 @@
             }
 
             // compute the TXVECTOR to use to send the MU-RTS Trigger Frame
-            protection->muRtsTxVector = GetWifiRemoteStationManager()->GetRtsTxVector(receiver);
+            protection->muRtsTxVector =
+                GetWifiRemoteStationManager()->GetRtsTxVector(receiver, txWidth);
             // The transmitter of an MU-RTS Trigger frame shall not request a non-AP STA to send
             // a CTS frame response in a 20 MHz channel that is not occupied by the PPDU that
             // contains the MU-RTS Trigger frame. (Sec. 26.2.6.2 of 802.11ax)
@@ -390,7 +394,7 @@
 
     // compute the TXVECTOR to use to send the MU-RTS Trigger Frame
     protection->muRtsTxVector =
-        GetWifiRemoteStationManager()->GetRtsTxVector(mpdu->GetHeader().GetAddr1());
+        GetWifiRemoteStationManager()->GetRtsTxVector(mpdu->GetHeader().GetAddr1(), txWidth);
     // The transmitter of an MU-RTS Trigger frame shall not request a non-AP STA to send
     // a CTS frame response in a 20 MHz channel that is not occupied by the PPDU that
     // contains the MU-RTS Trigger frame. (Sec. 26.2.6.2 of 802.11ax)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-mac.cc ns-3.41/src/wifi/model/wifi-mac.cc
--- ns-3.40/src/wifi/model/wifi-mac.cc	2023-09-27 13:30:37.918840000 -0700
+++ ns-3.41/src/wifi/model/wifi-mac.cc	2024-02-09 14:44:08.601795200 -0800
@@ -23,7 +23,7 @@
 #include "extended-capabilities.h"
 #include "mac-rx-middle.h"
 #include "mac-tx-middle.h"
-#include "mgt-headers.h"
+#include "mgt-action-headers.h"
 #include "qos-txop.h"
 #include "ssid.h"
 #include "wifi-mac-queue.h"
@@ -120,6 +120,14 @@
                           PointerValue(),
                           MakePointerAccessor(&WifiMac::GetBKQueue),
                           MakePointerChecker<QosTxop>())
+            .AddAttribute(
+                "MpduBufferSize",
+                "The size (in number of MPDUs) of the buffer used for each BlockAck "
+                "agreement in which this node is a recipient. The provided value is "
+                "capped to the maximum allowed value based on the supported standard.",
+                UintegerValue(1024),
+                MakeUintegerAccessor(&WifiMac::GetMpduBufferSize, &WifiMac::SetMpduBufferSize),
+                MakeUintegerChecker<uint16_t>(1, 1024))
             .AddAttribute("VO_MaxAmsduSize",
                           "Maximum length in bytes of an A-MSDU for AC_VO access class "
                           "(capped to 7935 for HT PPDUs and 11398 for VHT/HE/EHT PPDUs). "
@@ -289,19 +297,6 @@
                             "up from the physical layer.",
                             MakeTraceSourceAccessor(&WifiMac::m_macRxDropTrace),
                             "ns3::Packet::TracedCallback")
-            .AddTraceSource("TxOkHeader",
-                            "The header of successfully transmitted packet.",
-                            MakeTraceSourceAccessor(&WifiMac::m_txOkCallback),
-                            "ns3::WifiMacHeader::TracedCallback",
-                            TypeId::OBSOLETE,
-                            "Use the AckedMpdu trace instead.")
-            .AddTraceSource("TxErrHeader",
-                            "The header of unsuccessfuly transmitted packet.",
-                            MakeTraceSourceAccessor(&WifiMac::m_txErrCallback),
-                            "ns3::WifiMacHeader::TracedCallback",
-                            TypeId::OBSOLETE,
-                            "Depending on the failure type, use the NAckedMpdu trace, the "
-                            "DroppedMpdu trace or one of the traces associated with TX timeouts.")
             .AddTraceSource("AckedMpdu",
                             "An MPDU that was successfully acknowledged, via either a "
                             "Normal Ack or a Block Ack.",
@@ -433,6 +428,11 @@
 WifiMac::SetDevice(const Ptr<WifiNetDevice> device)
 {
     m_device = device;
+    if (GetHtSupported())
+    {
+        // the configured BlockAck buffer size can now be capped
+        m_mpduBufferSize = std::min(m_mpduBufferSize, GetMaxBaBufferSize());
+    }
 }
 
 Ptr<WifiNetDevice>
@@ -587,10 +587,8 @@
     // the PHY dependent parameters. In any case, this makes no harm
     ConfigurePhyDependentParameters(linkId);
 
-    // SetupPhy not only resets the remote station manager, but also sets the
-    // default TX mode and MCS, which is required when switching to a channel
-    // in a different band
-    GetLink(linkId).stationManager->SetupPhy(GetLink(linkId).phy);
+    // Reset remote station manager
+    GetLink(linkId).stationManager->Reset();
 }
 
 void
@@ -1404,7 +1402,7 @@
             continue;
         }
 
-        for (const auto [acIndex, ac] : wifiAcList)
+        for (const auto& [acIndex, ac] : wifiAcList)
         {
             // block queues storing QoS data frames and control frames that use MLD addresses
             m_scheduler->BlockQueues(reason,
@@ -1445,8 +1443,11 @@
             continue;
         }
 
-        for (const auto [acIndex, ac] : wifiAcList)
+        for (const auto& [acIndex, ac] : wifiAcList)
         {
+            // save the status of the AC queues before unblocking the requested queues
+            auto hasFramesToTransmit = GetQosTxop(acIndex)->HasFramesToTransmit(linkId);
+
             // unblock queues storing QoS data frames and control frames that use MLD addresses
             m_scheduler->UnblockQueues(reason,
                                        acIndex,
@@ -1465,14 +1466,11 @@
                                        {linkId});
             // request channel access if needed (schedule now because multiple invocations
             // of this method may be done in a loop at the caller)
-            auto qosTxop = GetQosTxop(acIndex);
-            Simulator::ScheduleNow([=]() {
-                if (qosTxop->GetAccessStatus(linkId) == Txop::NOT_REQUESTED &&
-                    qosTxop->HasFramesToTransmit(linkId))
-                {
-                    GetLink(linkId).channelAccessManager->RequestAccess(qosTxop);
-                }
-            });
+            Simulator::ScheduleNow(&Txop::StartAccessAfterEvent,
+                                   GetQosTxop(acIndex),
+                                   linkId,
+                                   hasFramesToTransmit,
+                                   Txop::CHECK_MEDIUM_BUSY); // generate backoff if medium busy
         }
     }
 }
@@ -1836,6 +1834,36 @@
     return false;
 }
 
+uint16_t
+WifiMac::GetMaxBaBufferSize(std::optional<Mac48Address> address) const
+{
+    if (address ? GetEhtSupported(*address) : GetEhtSupported())
+    {
+        return 1024;
+    }
+    if (address ? GetHeSupported(*address) : GetHeSupported())
+    {
+        return 256;
+    }
+    NS_ASSERT(address ? GetHtSupported(*address) : GetHtSupported());
+    return 64;
+}
+
+void
+WifiMac::SetMpduBufferSize(uint16_t size)
+{
+    NS_LOG_FUNCTION(this << size);
+
+    // the cap can be computed if the device has been configured
+    m_mpduBufferSize = m_device ? std::min(size, GetMaxBaBufferSize()) : size;
+}
+
+uint16_t
+WifiMac::GetMpduBufferSize() const
+{
+    return m_mpduBufferSize;
+}
+
 void
 WifiMac::SetVoBlockAckThreshold(uint8_t threshold)
 {
@@ -1940,7 +1968,7 @@
     capabilities.SetLdpc(htConfiguration->GetLdpcSupported());
     capabilities.SetSupportedChannelWidth(htConfiguration->Get40MHzOperationSupported() ? 1 : 0);
     capabilities.SetShortGuardInterval20(sgiSupported);
-    capabilities.SetShortGuardInterval40(phy->GetChannelWidth() >= 40 && sgiSupported);
+    capabilities.SetShortGuardInterval40(sgiSupported);
     // Set Maximum A-MSDU Length subfield
     uint16_t maxAmsduSize =
         std::max({m_voMaxAmsduSize, m_viMaxAmsduSize, m_beMaxAmsduSize, m_bkMaxAmsduSize});
@@ -1966,7 +1994,9 @@
         capabilities.SetRxMcsBitmask(mcs.GetMcsValue());
         uint8_t nss = (mcs.GetMcsValue() / 8) + 1;
         NS_ASSERT(nss > 0 && nss < 5);
-        uint64_t dataRate = mcs.GetDataRate(phy->GetChannelWidth(), sgiSupported ? 400 : 800, nss);
+        uint64_t dataRate = mcs.GetDataRate(htConfiguration->Get40MHzOperationSupported() ? 40 : 20,
+                                            sgiSupported ? 400 : 800,
+                                            nss);
         if (dataRate > maxSupportedRate)
         {
             maxSupportedRate = dataRate;
@@ -2022,8 +2052,8 @@
     capabilities.SetMaxAmpduLength(std::min(std::max(maxAmpduLength, 8191U), 1048575U));
 
     capabilities.SetRxLdpc(htConfiguration->GetLdpcSupported());
-    capabilities.SetShortGuardIntervalFor80Mhz((phy->GetChannelWidth() == 80) && sgiSupported);
-    capabilities.SetShortGuardIntervalFor160Mhz((phy->GetChannelWidth() == 160) && sgiSupported);
+    capabilities.SetShortGuardIntervalFor80Mhz(sgiSupported);
+    capabilities.SetShortGuardIntervalFor160Mhz(sgiSupported);
     uint8_t maxMcs = 0;
     for (const auto& mcs : phy->GetMcsList(WIFI_MOD_CLASS_VHT))
     {
@@ -2042,15 +2072,16 @@
         capabilities.SetTxMcsMap(maxMcs, nss);
     }
     uint64_t maxSupportedRateLGI = 0; // in bit/s
+    uint16_t maxWidth = vhtConfiguration->Get160MHzOperationSupported() ? 160 : 80;
     for (const auto& mcs : phy->GetMcsList(WIFI_MOD_CLASS_VHT))
     {
-        if (!mcs.IsAllowed(phy->GetChannelWidth(), 1))
+        if (!mcs.IsAllowed(maxWidth, 1))
         {
             continue;
         }
-        if (mcs.GetDataRate(phy->GetChannelWidth()) > maxSupportedRateLGI)
+        if (mcs.GetDataRate(maxWidth) > maxSupportedRateLGI)
         {
-            maxSupportedRateLGI = mcs.GetDataRate(phy->GetChannelWidth());
+            maxSupportedRateLGI = mcs.GetDataRate(maxWidth);
             NS_LOG_DEBUG("Updating maxSupportedRateLGI to " << maxSupportedRateLGI);
         }
     }
@@ -2074,18 +2105,20 @@
 
     Ptr<WifiPhy> phy = GetLink(linkId).phy;
     Ptr<HtConfiguration> htConfiguration = GetHtConfiguration();
+    Ptr<VhtConfiguration> vhtConfiguration = GetVhtConfiguration();
     Ptr<HeConfiguration> heConfiguration = GetHeConfiguration();
     uint8_t channelWidthSet = 0;
-    if ((phy->GetChannelWidth() >= 40) && (phy->GetPhyBand() == WIFI_PHY_BAND_2_4GHZ))
+    if ((htConfiguration->Get40MHzOperationSupported()) &&
+        (phy->GetPhyBand() == WIFI_PHY_BAND_2_4GHZ))
     {
         channelWidthSet |= 0x01;
     }
-    if (((phy->GetChannelWidth() >= 80) || GetEhtSupported()) &&
-        ((phy->GetPhyBand() == WIFI_PHY_BAND_5GHZ) || (phy->GetPhyBand() == WIFI_PHY_BAND_6GHZ)))
+    // we assume that HE stations support 80 MHz operations
+    if ((phy->GetPhyBand() == WIFI_PHY_BAND_5GHZ) || (phy->GetPhyBand() == WIFI_PHY_BAND_6GHZ))
     {
         channelWidthSet |= 0x02;
     }
-    if ((phy->GetChannelWidth() >= 160) &&
+    if ((vhtConfiguration->Get160MHzOperationSupported()) &&
         ((phy->GetPhyBand() == WIFI_PHY_BAND_5GHZ) || (phy->GetPhyBand() == WIFI_PHY_BAND_6GHZ)))
     {
         channelWidthSet |= 0x04;
@@ -2167,7 +2200,7 @@
 
     const uint8_t maxTxNss = phy->GetMaxSupportedTxSpatialStreams();
     const uint8_t maxRxNss = phy->GetMaxSupportedRxSpatialStreams();
-    if (phy->GetChannelWidth() == 20)
+    if (auto htConfig = GetHtConfiguration(); !htConfig->Get40MHzOperationSupported())
     {
         for (auto maxMcs : {7, 9, 11, 13})
         {
@@ -2195,7 +2228,7 @@
                 phy->IsMcsSupported(WIFI_MOD_CLASS_EHT, maxMcs) ? maxTxNss : 0);
         }
     }
-    if (phy->GetChannelWidth() >= 160)
+    if (auto vhtConfig = GetVhtConfiguration(); vhtConfig->Get160MHzOperationSupported())
     {
         for (auto maxMcs : {9, 11, 13})
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-mac.h ns-3.41/src/wifi/model/wifi-mac.h
--- ns-3.40/src/wifi/model/wifi-mac.h	2023-09-27 13:30:37.918840000 -0700
+++ ns-3.41/src/wifi/model/wifi-mac.h	2024-02-09 14:44:08.601795200 -0800
@@ -679,6 +679,27 @@
     BlockAckReqType GetBarTypeAsRecipient(Mac48Address originator, uint8_t tid) const;
 
     /**
+     * Get the maximum Block Ack buffer size (in number of MPDUs) supported by the given device,
+     * if any, or by this device, otherwise, based on the supported standard.
+     *
+     * \param address the (MLD or link) address of the given device
+     * \return the maximum supported Block Ack buffer size (in number of MPDUs)
+     */
+    uint16_t GetMaxBaBufferSize(std::optional<Mac48Address> address = std::nullopt) const;
+
+    /**
+     * \param size the size (in number of MPDUs) of the buffer used for each BlockAck
+     *             agreement in which this node is a recipient
+     */
+    void SetMpduBufferSize(uint16_t size);
+
+    /**
+     * \return the size (in number of MPDUs) of the buffer used for each BlockAck
+     *             agreement in which this node is a recipient
+     */
+    uint16_t GetMpduBufferSize() const;
+
+    /**
      * Get the TID-to-Link Mapping negotiated with the given MLD (if any) for the given direction.
      * An empty mapping indicates the default mapping.
      *
@@ -1054,6 +1075,8 @@
     uint32_t m_beMaxAmpduSize; ///< maximum A-MPDU size for AC_BE (in bytes)
     uint32_t m_bkMaxAmpduSize; ///< maximum A-MPDU size for AC_BK (in bytes)
 
+    uint16_t m_mpduBufferSize; //!< BlockAck buffer size (in number of MPDUs)
+
     /// @brief DL TID-to-Link Mapping negotiated with an MLD (identified by its MLD address)
     std::unordered_map<Mac48Address, WifiTidLinkMapping, WifiAddressHash> m_dlTidLinkMappings;
     /// @brief UL TID-to-Link Mapping negotiated with an MLD (identified by its MLD address)
@@ -1099,9 +1122,6 @@
      */
     TracedCallback<Ptr<const Packet>> m_macRxDropTrace;
 
-    TracedCallback<const WifiMacHeader&> m_txOkCallback;  ///< transmit OK callback
-    TracedCallback<const WifiMacHeader&> m_txErrCallback; ///< transmit error callback
-
     /**
      * TracedCallback signature for MPDU drop events.
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-mac-queue-scheduler-impl.h ns-3.41/src/wifi/model/wifi-mac-queue-scheduler-impl.h
--- ns-3.40/src/wifi/model/wifi-mac-queue-scheduler-impl.h	2023-09-27 13:30:37.914839700 -0700
+++ ns-3.41/src/wifi/model/wifi-mac-queue-scheduler-impl.h	2024-02-09 14:44:08.601795200 -0800
@@ -450,7 +450,7 @@
     std::list<uint8_t> linkIds;
 
     // include only links that are not blocked in the returned list
-    for (const auto [linkId, mask] : queueInfoIt->second.linkIds)
+    for (const auto& [linkId, mask] : queueInfoIt->second.linkIds)
     {
         if (mask.none())
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-mpdu.cc ns-3.41/src/wifi/model/wifi-mpdu.cc
--- ns-3.40/src/wifi/model/wifi-mpdu.cc	2023-09-27 13:30:37.918840000 -0700
+++ ns-3.41/src/wifi/model/wifi-mpdu.cc	2024-02-09 14:44:08.601795200 -0800
@@ -174,9 +174,15 @@
 void
 WifiMpdu::Aggregate(Ptr<const WifiMpdu> msdu)
 {
-    NS_ASSERT(msdu);
-    NS_LOG_FUNCTION(this << *msdu);
-    NS_ABORT_MSG_IF(!msdu->GetHeader().IsQosData() || msdu->GetHeader().IsQosAmsdu(),
+    if (msdu)
+    {
+        NS_LOG_FUNCTION(this << *msdu);
+    }
+    else
+    {
+        NS_LOG_FUNCTION(this);
+    }
+    NS_ABORT_MSG_IF(msdu && (!msdu->GetHeader().IsQosData() || msdu->GetHeader().IsQosAmsdu()),
                     "Only QoS data frames that do not contain an A-MSDU can be aggregated");
     NS_ABORT_MSG_IF(!std::holds_alternative<OriginalInfo>(m_instanceInfo),
                     "This method can only be called on the original version of the MPDU");
@@ -206,7 +212,10 @@
         // to be set to the BSSID, but neither Address 1 nor Address 2 contain the
         // BSSID. Hence, it is left up to the caller to set these Address fields.
     }
-    DoAggregate(msdu);
+    if (msdu)
+    {
+        DoAggregate(msdu);
+    }
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-mpdu.h ns-3.41/src/wifi/model/wifi-mpdu.h
--- ns-3.40/src/wifi/model/wifi-mpdu.h	2023-09-27 13:30:37.918840000 -0700
+++ ns-3.41/src/wifi/model/wifi-mpdu.h	2024-02-09 14:44:08.601795200 -0800
@@ -131,7 +131,9 @@
     /**
      * \brief Aggregate the MSDU contained in the given MPDU to this MPDU (thus
      *        constituting an A-MSDU). Note that the given MPDU cannot contain
-     *        an A-MSDU.
+     *        an A-MSDU. If the given MPDU is a null pointer, the effect of this
+     *        call is to add only an A-MSDU subframe header, thus producing an A-MSDU
+     *        containing a single MSDU.
      * \param msdu the MPDU containing the MSDU to aggregate
      */
     void Aggregate(Ptr<const WifiMpdu> msdu);
